// Generated by CoffeeScript 1.12.2
(function() {
  var $, _, _coffee, _yaml, argv, coffee, fs, gulp, include, lint, path, plumber, project, replace, task, uglify, using, watch, yaml;

  $ = require('./index');

  _ = $._;

  fs = require('fs');

  argv = require('minimist')(process.argv.slice(2));

  gulp = require('gulp');

  watch = require('gulp-watch');

  plumber = require('gulp-plumber');

  include = require('gulp-include');

  replace = require('gulp-replace');

  using = require('gulp-using');

  coffee = require('gulp-coffee');

  yaml = require('gulp-yaml');

  uglify = require('gulp-uglify');

  lint = require('gulp-coffeelint');

  $.log = console.log;

  $.i = function(msg) {
    $.log(msg);
    return msg;
  };

  $.info = function(type, msg) {
    console.log("<" + (type.toUpperCase()) + "> " + msg);
    return msg;
  };

  $.shell = function(cmd, callback) {
    var child, fn;
    fn = $.shell;
    fn.platform || (fn.platform = (require('os')).platform());
    fn.exec || (fn.exec = (require('child_process')).exec);
    fn.info || (fn.info = function(string) {
      var text;
      text = $.trim(string);
      if (!text.length) {
        return;
      }
      return $.log(text.replace(/\r/g, '\n').replace(/\n{2,}/g, ''));
    });
    if ($.type(cmd) === 'array') {
      cmd = fn.platform === 'win32' ? cmd.join('&') : cmd.join('&&');
    }
    $.info('shell', cmd);
    child = fn.exec(cmd);
    child.stdout.on('data', function(data) {
      return fn.info(data);
    });
    child.stderr.on('data', function(data) {
      return fn.info(data);
    });
    return child.on('close', function() {
      return typeof callback === "function" ? callback() : void 0;
    });
  };

  task = {};

  $.task = function(name, fn) {
    gulp.task(name, function() {
      $.info('base', "running at " + project.base);
      return task[name]();
    });
    return task[name] = fn;
  };

  project = {
    base: process.cwd()
  };

  project.name = project.base.replace(/.*\\|.*\//, '');

  path = {
    source: './source'
  };

  path.coffee = path.source + "/**/*.coffee";

  _coffee = function() {
    return coffee({
      map: true
    });
  };

  _yaml = function() {
    return yaml({
      safe: true
    });
  };

  $.task('watch', function() {
    var list;
    list = [path.source + "/script/index.coffee", path.source + "/script/include/**/*.coffee"];
    return watch(list, function() {
      return task.build();
    });
  });

  $.task('build', function() {
    var fn;
    fn = {};
    fn.coffee = function(cb) {
      return gulp.src(path.source + "/script/index.coffee").pipe(plumber()).pipe(using()).pipe(include()).pipe(_coffee()).pipe(uglify()).pipe(gulp.dest('./')).on('end', function() {
        return typeof cb === "function" ? cb() : void 0;
      });
    };
    return fn.coffee();
  });

  $.task('lint', function() {
    return gulp.src(['./gulpfile.coffee', './test.coffee', path.coffee]).pipe(plumber()).pipe(using()).pipe(lint()).pipe(lint.reporter());
  });

  $.task('prepare', function() {
    return gulp.src('./coffeelint.yml').pipe(plumber()).pipe(using()).pipe(_yaml()).pipe(gulp.dest('./'));
  });

  $.task('work', function() {
    return $.shell('gulp watch');
  });

  $.task('noop', function() {
    return null;
  });

  $.task('test', function() {
    return $.shell('node test.js');
  });

  $.task('set', function() {
    var fn, ver;
    if (!(ver = argv.version)) {
      return;
    }
    fn = {};
    fn["package"] = function(cb) {
      var src;
      src = 'package.json';
      return gulp.src(src).pipe(plumber()).pipe(using()).pipe(replace(/"version": "[\d.]+"/, "\"version\": \"" + ver + "\"")).pipe(gulp.dest('')).on('end', function() {
        return typeof cb === "function" ? cb() : void 0;
      });
    };
    fn.init = function(cb) {
      var src;
      src = path.source + "/script/include/init.coffee";
      return gulp.src(src, {
        base: path.source
      }).pipe(plumber()).pipe(using()).pipe(replace(/version: '[\d.]+'/, "version: '" + ver + "'")).pipe(gulp.dest(path.source)).on('end', function() {
        return typeof cb === "function" ? cb() : void 0;
      });
    };
    fn.test = function(cb) {
      var src;
      src = 'test.coffee';
      return gulp.src(src).pipe(plumber()).pipe(using()).pipe(replace(/version = '[\d.]+'/, "version = '" + ver + "'")).pipe(gulp.dest('')).on('end', function() {
        return typeof cb === "function" ? cb() : void 0;
      });
    };
    return fn["package"](function() {
      return fn.init(function() {
        return fn.test();
      });
    });
  });

}).call(this);

//# sourceMappingURL=gulpfile.js.map
